<?php
#!/usr/bin/php -q

//STANDARD SCRIPT SERVER HEADER!!!
$no_http_headers = true;

/* display No errors */
error_reporting(E_ERROR);

include_once(dirname(__FILE__) . "/../include/config.php");

function jtm_RemoteStats($ssurl){
     if(!eregi('http://', $ssurl))
        $ssurl = "http://$ssurl/serverstats.php";
     if(($response = cache($ssurl)) === false){
        $response = fetchStats($ssurl);
	    cache($ssurl, $response);
     }

	 return trim($response);
} 

function jtm_QueryDiskIndex($ssurl, $ret = false){
     if(!eregi('http://', $ssurl))
        $ssurl = "http://$ssurl/serverstats.php";

     if(($response = cache($ssurl.'-disk')) === false){
        $response = fetchStats($ssurl,'diskinfo');
	    cache($ssurl.'-disk', $response);
     }
     $info = unserialize($response);

     if($ret == false)
       print join("\n", array_keys($info['disks'])) . "\n";
     else
	   return $info;
}

function jtm_QueryDiskGet($ssurl, $item, $device){
   $info = jtm_QueryDiskIndex($ssurl, true);
   echo $info['disks'][$device][$item];
}

function jtm_QueryDiskQuery($ssurl, $item){
   $info = jtm_QueryDiskIndex($ssurl, true);
   foreach($info['disks'] as $diskid => $disk){
     if($item == 'diskdrive') 
        echo $diskid . ':' . $diskid . "\n";
     else
        echo $diskid . ':' . $disk[$item] . "\n";
   }
}

function jtm_QueryMountIndex($ssurl){
   $info = jtm_QueryDiskIndex($ssurl, true);
   print join("\n", array_keys($info['partitions'])) . "\n";
}

function jtm_QueryMountGet($ssurl, $item, $device){
   $info = jtm_QueryDiskIndex($ssurl, true);
   echo $info['partitions'][$device][$item];
}

function jtm_QueryMountQuery($ssurl, $item){
   $pg = '';
   if($item == 'percent_pg'){
      $item = 'percent';
      $pg = ' %';
   }
   
   $info = jtm_QueryDiskIndex($ssurl, true);
   foreach($info['partitions'] as $disk){
        echo $disk['device'] . ':' . $disk[$item] . $pg . "\n";
   }
}

function fetchStats($ssurl, $type = 'all'){
	    $ch = curl_init();
	    
	    $url = sprintf("%s?o=%s", $ssurl, $type);

	    // Option settings for curl
	    curl_setopt($ch,CURLOPT_URL, $url);
	    curl_setopt($ch,CURLOPT_HTTPHEADER,array("Connection: keep-alive","Expect:","User-Agent: Saturn Monitoring Poller"));

	    curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
	    $rs = trim(curl_exec($ch));
	    
    return gzuncompress(base64_decode($rs));
}

function cache($ssurl, $data = false){
    return false;
    $cacheFile = '/dev/shm/' . md5($ssurl) . '.cache';
    if($data !== false){
      file_put_contents($cacheFile, $data);
      return;  
    }
    if(!file_exists($cacheFile))
        return false;
    if( (time() - filemtime($cacheFile)) > 290 )
        return false;
    return file_get_contents($cacheFile);
}

if (!isset($called_by_script_server)) {
    array_shift($_SERVER["argv"]);
	$method = array_shift($_SERVER["argv"]);
	if(!eregi('jtm_', $method)){
	  $rmi_url = $method;
	  $method = array_shift($_SERVER["argv"]);
	  array_unshift($_SERVER["argv"], $rmi_url);
	}
	if(function_exists($method))
      print call_user_func_array($method, $_SERVER["argv"]);
}


// data security .. encrypt messages to the server.. 
// make sure that none can send commands to the mysql server 
// if bidirectional encryption is needed, the decrypt
// should be added here and used where necessary

if(!function_exists('encrypt')){
    # ============================================================================
    # Encrypts string {$string} and returns the Base64_Encoded encrypted text
    # Though this does the job, I cant guarantee that this is unbreakable.
    # ============================================================================
    function encrypt($string){
        $encrypted = '';
        $key = 'Though this does the job, I cant guarantee that this is unbreakable'; // change this to some unique value.. 
        for( $i = 0; $i < strlen($string); $i++){
                $c = ord(substr($string, $i));
                $c += ord(substr($key, (($i + 1) % strlen($key))));
                $encrypted .= chr($c & 0xFF);
        }
        return base64_encode($encrypted);
    }
}

